/* Dingoo Test Program
 Rodrigo Cardoso
 
 License: Do Whatever you want, no warranties. ;)
 
 Credits: There are some come i got looking in dingoonity forums,
 please take a look there for more info :P
 */

#pragma once //include guard


#include <stdlib.h>
#include <stdio.h> 
#include <fcntl.h>    /* For O_RDWR */
#include <unistd.h>   /* For open(), creat() */
#include <sys/ioctl.h>


// I'm testing the interface in an Apple machine...
#if !defined (__APPLE__)

#include <linux/soundcard.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "jz4740.h"
#include "dingoo_clock.h"

#endif


#define DINGOO_LEFT          SDLK_LEFT
#define DINGOO_RIGHT         SDLK_RIGHT
#define DINGOO_UP            SDLK_UP
#define DINGOO_DOWN          SDLK_DOWN

#define DINGOO_Y             SDLK_LSHIFT
#define DINGOO_A             SDLK_LCTRL
#define DINGOO_X             SDLK_SPACE
#define DINGOO_B             SDLK_LALT

#define DINGOO_L             SDLK_TAB
#define DINGOO_R             SDLK_BACKSPACE

#define DINGOO_START         SDLK_RETURN
#define DINGOO_SELECT        SDLK_ESCAPE

// again, for testing purposes...
#if !defined (__APPLE__)

#define DINGOO_POWER        SDLK_UNKNOWN
#define DINGOO_HOLD			SDLK_PAUSE // The stupid Apple keyboard does not have this key :P

#else

#define DINGOO_POWER        SDLK_EQUALS
#define DINGOO_HOLD			SDLK_MINUS

#endif

#if !defined(__APPLE__)

int get_battery_level(void)
{
	FILE *FP;
	int mvolts;
	char buf[6]={};
	FP = fopen("/proc/jz/battery", "rb");
	if (!FP) return(0);
	fgets(buf, 5, FP);
	fclose(FP);
 	sscanf(buf, "%d", &mvolts);
	return (mvolts);
}

void set_brightness(int value)
{
	unsigned long dev=open("/proc/jz/lcd_backlight", O_RDWR);
	if (dev)
	{
		char backlight[4];
		if (value > 99) value = 99;
		if (value < 0) value = 0;
		snprintf(backlight, 3, "%d", value);
		backlight[3]='\0';
		write(dev, backlight, 4);
		close(dev);
		sync();
	}
}

int get_brightness(void)
{
	unsigned long dev=open("/proc/jz/lcd_backlight", O_RDWR);
	if (dev)
	{
		char backlight[4]={ 0, 0, 0, 0 };
		read(dev, backlight, 4);
		backlight[3]='\0';
		close(dev);
		return 1+atoi(backlight);
	}
	return 0;
}

void set_vol(int value)
{
	unsigned long dev=open("/dev/mixer", O_WRONLY);
	if (dev)
	{
		if (value > 100) value = 100;
		if (value < 0) value = 0;
		value|=(value<<8);
		ioctl(dev, SOUND_MIXER_WRITE_VOLUME, &value);
		close(dev);
		sync();
	}
}

int get_vol(void)
{
	unsigned long dev=open("/dev/mixer", O_WRONLY);
	if (dev)
	{
		int value=0;
		ioctl(dev, SOUND_MIXER_READ_VOLUME, &value);
		close(dev);
		return value&0xff;
	}
	return 0;
}

#else

// Dont want the IDE annoying me "not used variable" bla bla blah...
#define nothing(a)				SDL_Delay(a)

// Just for interface testing purposes.
#define get_battery_level()		3500
#define set_brightness(a)		nothing(a)
#define get_brightness()		99
#define set_vol(a)				nothing(a)
#define get_vol()				0

#define set_clock(a)			nothing(a)
#define get_clock()				0

#endif
